<template lang="html">
  <flex dir="column">
    <butter-block>
      <butter-icon name="intro-graphic2" slot="graphic" />
      <h1>Step 2:</h1>
      <h2>Create a Client</h2>
      <p>Clients have tokens assigned to them and track inividual users that use these tokens to track their usage.</p>
    </butter-block>
    <butter-block>
      <template slot="header">
        <h1>Clients <span>Clients are used to authenticate to the <a>Blockser API.</a></span></h1>
        <butter-button size="small" @click.native="modal.opened=true">Create Client</butter-button>
      </template>
      <account-clients :clients="clients" :users="clientUsers" :userPage="userPage" :clientId="selectedClient" @select="selectedClient = $event.clientId" @editClient="modal.opened=true" @paginate="fetchUsers" class="filtered-content" />
    </butter-block>
    <modal v-show="modal.opened" title="Name New Client" size="small">
      <p>Enter the name of your new API Client</p>
      <butter-input label="Client Name" />
      <template slot="actions">
        <flex>
          <butter-button theme="secondary" size="large" @click.native="modal.opened=false">Cancel</butter-button>
          <butter-button size="large">Save</butter-button>
        </flex>
        <butter-button size="large" theme="error-alt">Delete Client</butter-button>
      </template>
    </modal>
  </flex>
</template>

<script>
export default {
  layout: 'blockset',
  data() {
    return {
      modal: {
        opened: false,
      },
      selectedClient: "1234",
      userPage: { start: 1, end: 1, total: 1},
      clients: [
        {
          clientId: "1234",
          name: '',
          users: [
            {
              userId: '3208234',
              created: '2021-08-19',
              deviceId: '1aa1a58b-a662-4649-b2a8-dce7b6e6590e'
            }
          ],
          tokens: {
            token: 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJjZTk2MDFlOS04MzAwLTQ0YmEtOTcyZi1iZTUyMWQzZWQ2OWUiLCJicmQ6Y3QiOiJjbGkiLCJleHAiOjkyMjMzNzIwMzY4NTQ3NzUsImlhdCI6MTYyOTQzNzU2MH0.YPGVzNFn11h6vkn_miOtONziZIo2p3IPTVTYz_uhjGORZsVUhZvQAmj4a7nVxYZ2y1m__XezELV2HqNUqpe2xA',
            embedToken: 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJjZTk2MDFlOS04MzAwLTQ0YmEtOTcyZi1iZTUyMWQzZWQ2OWUiLCJicmQ6Y3QiOiJjbGkiLCJleHAiOjkyMjMzNzIwMzY4NTQ3NzUsImlhdCI6MTYyOTQzNzU2MH0.YPGVzNFn11h6vkn_miOtONziZIo2p3IPTVTYz_uhjGORZsVUhZvQAmj4a7nVxYZ2y1m__XezELV2HqNUqpe2xA'
          },
        },
        {
          clientId: "5678",
          name: 'Name #2',
          users: [
            {
              userId: '7894566',
              created: '2021-08-19',
              deviceId: '1aa1a58b-a662-4649-b2a8-dce7b6e6590e'
            },
            {
              userId: '5486254',
              created: '2021-08-19',
              deviceId: '1aa1a58b-fghd-4649-asdw-dce7b6e6590e'
            },{
              userId: '7894566',
              created: '2021-08-19',
              deviceId: '1aa1a58b-a662-4649-b2a8-dce7b6e6590e'
            },
            {
              userId: '5486254',
              created: '2021-08-19',
              deviceId: '1aa1a58b-fghd-4649-asdw-dce7b6e6590e'
            },{
              userId: '7894566',
              created: '2021-08-19',
              deviceId: '1aa1a58b-a662-4649-b2a8-dce7b6e6590e'
            },
            {
              userId: '5486254',
              created: '2021-08-19',
              deviceId: '1aa1a58b-fghd-4649-asdw-dce7b6e6590e'
            },{
              userId: '7894566',
              created: '2021-08-19',
              deviceId: '1aa1a58b-a662-4649-b2a8-dce7b6e6590e'
            },
            {
              userId: '5486254',
              created: '2021-08-19',
              deviceId: '1aa1a58b-fghd-4649-asdw-dce7b6e6590e'
            },{
              userId: '7894566',
              created: '2021-08-19',
              deviceId: '1aa1a58b-a662-4649-b2a8-dce7b6e6590e'
            },
            {
              userId: '5486254',
              created: '2021-08-19',
              deviceId: '1aa1a58b-fghd-4649-asdw-dce7b6e6590e'
            }
          ],
          tokens: {
            token: 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJjZTk2MDFlOS04MzAwLTQ0YmEtOTcyZi1iZTUyMWQzZWQ2OWUiLCJicmQ6Y3QiOiJjbGkiLCJleHAiOjkyMjMzNzIwMzY4NTQ3NzUsImlhdCI6MTYyOTQzNzU2MH0.YPGVzNFn11h6vkn_miOtONziZIo2p3IPTVTYz_uhjGORZsVUhZvQAmj4a7nVxYZ2y1m__XezELV2HqNUqpe2xA',
            embedToken: 'eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJzdWIiOiJjZTk2MDFlOS04MzAwLTQ0YmEtOTcyZi1iZTUyMWQzZWQ2OWUiLCJicmQ6Y3QiOiJjbGkiLCJleHAiOjkyMjMzNzIwMzY4NTQ3NzUsImlhdCI6MTYyOTQzNzU2MH0.YPGVzNFn11h6vkn_miOtONziZIo2p3IPTVTYz_uhjGORZsVUhZvQAmj4a7nVxYZ2y1m__XezELV2HqNUqpe2xA'
          },
        }
      ],
    };
  },
  computed: {
    clientUsers() {
      const client = this.clients.find(c => c.clientId == this.selectedClient);
      return client && client.users
    },
  },
  methods: {
    fetchUsers(e) {
      this.userPage.start += (e == 'next') ? 2 : -2;
      this.userPage.end += (e == 'next') ? 2 : -2;
    }
  }
}
</script>

<style lang="scss" scoped>
</style>
